from peri import PeriBoard
from time import sleep
from random import random

p = PeriBoard()

def clear() :
    print'\x1b[2J\x1b[1;1H'

def rand(maxNum) :
    return (int)(random()*maxNum + 1)

def randomUnit(maxUnit,data,type) :
   i = 0
   while i < maxUnit :
        position = rand(5) - 1
        if data[position] == 0 :
            data[position] = type
            i += 1
       
def countUnit(data,type) :
    count = 0
    for item in data :
        if item == type :
            count += 1
    return count

def Led(data) :
    i = 0 
    while i < 5 :
        if data[i] == 1 :
            p.setLedNum('G',i+1,1) 
            p.setLedNum('R',i+1,0)
        elif data[i] == -1 :
            p.setLedNum('G',i+1,0)
            p.setLedNum('R',i+1,1)
        elif data[i] == 0 :
           p.setLedNum('G',i+1,0)
           p.setLedNum('R',i+1,0)
        i += 1

def Led2(type) :
    if type == 1 :
        p.setLedNum('G',6,1)
    elif type == -1 :
        p.setLedNum('G',6,0)
       

def setState(turn) :
    return turn/5 + 1

###########################################

def setGame(turn,data) :
    state = setState(turn) 
    if state == 1 :
        randomUnit(3,data,1)
        return 4    
    elif state == 2 :
        randomUnit(1,data,1)
        return 1.5
    elif state == 3 :
        randomUnit(2,data,1)
        randomUnit(2,data,-1)
        return 3
    else :
        temp = rand(5)
        randomUnit(temp,data,1)
        if temp == 5 :
            temp2 = 0
        else :
            temp2 = rand(5-temp)
        randomUnit(temp2,data,-1)
        return 3

def setGame2(turn) :
    if setState(turn) > 3 :
       temp = rand(2)
       if temp == 1 :
           return 1
       else :
           return -1
    else :
        return 1
           
###########################################

def startGame() :
   i = 0
   while i < 3 :
       p.setLedNum('G',1,1)
       sleep(0.2)
       p.setLedNum('G',1,0)
       p.setLedNum('G',2,1)
       sleep(0.2)
       p.setLedNum('G',2,0)
       p.setLedNum('G',5,1)
       sleep(0.2)
       p.setLedNum('G',5,0)
       p.setLedNum('G',4,1)
       sleep(0.2)
       p.setLedNum('G',4,0)
       i += 1

def gameOver() :
   i = 0
   while i < 5 :
      data = [-1,-1,-1,-1,-1]
      Led(data)
      sleep(0.5)
      data = [0,0,0,0,0]
      Led(data)
      sleep(0.5)
      i += 1


def checkScore(data,score,type) :
    sw = []
    i = 0
    while i < 5 :
        sw.append(p.getSwitch(i+1))
        i += 1
    i = 0
    while i < 5 :
        if data[i] == 1 * type and sw[i] == True :
            data[i] = 0
            Led(data) 
            score += 1
            sleep(0.1)
        elif data[i] == (-1) * type and sw[i] == True :
            data[0] = 2
            return score
        elif data[i] == 0 and sw[i] == True :
            score -= 1
            sleep(0.1)
        i += 1
           
    return score

#################################################

while True :
    clear()
    data = [0,0,0,0,0]
    Led(data)
    p.setLedNum('G',6,0)
    print "Start Game"
    startGame()
    turn = 0
    score = 0 
    life = 1 
    while True :
        data = [0,0,0,0,0]
        Led(data)
        sleep(1)
        maxTime = setGame(turn,data)
        type = setGame2(turn)
        Led(data)
        Led2(type)
        time = 0
        if life == 0 :
            break 
        else :
            while time < maxTime * 10 :
                clear()
                print "score = {0}" .format(score)
                print "state = {0}" .format(setState(turn))
                score = checkScore(data,score,type)
                if score <= -10 or data[0] == 2 :
                    life = 0
                    break 
                time += 1
                sleep(0.05)
        if type == 1 and life == 1 :
            score -= countUnit(data,1)
        elif type == -1 and life == 1:
            score -= countUnit(data,-1)
        turn += 1
    clear()
    print "GameOver"
    print "You Score = {0}" .format(score)
    gameOver()
            
             

        
